#include <pcl/point_types.h>
#include <pcl/filters/passthrough.h>
#include <pcl/io/pcd_io.h>
#include <opencv2/core.hpp>
#include <opencv2/opencv.hpp>

int main() {
    pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZRGB>);
    pcl::io::loadPCDFile<pcl::PointXYZRGB>("../cloudA.pcd", *cloud);

    int camera_height = cloud->height;
    int camera_width = cloud->width;
    cv::Mat pcl_image(camera_height, camera_width, CV_8UC3);

    for (int y = 0; y < camera_height; y++) {
        for (int x = 0; x < camera_width; x++) {
            cv::Vec3b color = cv::Vec3b(
                cloud->points.at(y * camera_width + x).b,
                cloud->points.at(y * camera_width + x).g,
                cloud->points.at(y * camera_width + x).r);

            pcl_image.at<cv::Vec3b>(cv::Point(x, y)) = color;
        }
    }

    cv::imshow("PointCloud Image", pcl_image);
    cv::waitKey(0);

    return 0;
}

